diff options
author | Junio C Hamano <junkio@cox.net> | 2007-01-14 22:00:02 -0800 |
---|---|---|
committer | Junio C Hamano <junkio@cox.net> | 2007-01-14 22:00:34 -0800 |
commit | acb4441e0dabaaa666ecae11fdafc27c3691e763 (patch) | |
tree | 817c8d77b06c1561672221b90800de115b171bc0 /git-revert.sh | |
parent | 5fe3acc43ddb30c61f0adc922f1f08ccc117d2c1 (diff) | |
download | git-acb4441e0dabaaa666ecae11fdafc27c3691e763.tar.gz |
Use merge-recursive in git-revert/git-cherry-pick
This makes revert and cherry-pick to use merge-recursive, to
allow them to notice renames. A pair of test scripts
demonstrate that an old change before a rename happened can be
applied (reverted) after a rename with cherry-pick (with revert).
Signed-off-by: Junio C Hamano <junkio@cox.net>
Diffstat (limited to 'git-revert.sh')
-rwxr-xr-x | git-revert.sh | 29 |
1 files changed, 12 insertions, 17 deletions
diff --git a/git-revert.sh b/git-revert.sh index 71cbcbc2b8..c74af99a51 100755 --- a/git-revert.sh +++ b/git-revert.sh @@ -151,32 +151,27 @@ esac >.msg # and $prev on top of us (when reverting), or the change between # $prev and $commit on top of us (when cherry-picking or replaying). -echo >&2 "First trying simple merge strategy to $me." -git-read-tree -m -u --aggressive $base $head $next && +git-merge-recursive $base -- $head $next && result=$(git-write-tree 2>/dev/null) || { - echo >&2 "Simple $me fails; trying Automatic $me." - git-merge-index -o git-merge-one-file -a || { - mv -f .msg "$GIT_DIR/MERGE_MSG" - { - echo ' + mv -f .msg "$GIT_DIR/MERGE_MSG" + { + echo ' Conflicts: ' git ls-files --unmerged | sed -e 's/^[^ ]* / /' | uniq - } >>"$GIT_DIR/MERGE_MSG" - echo >&2 "Automatic $me failed. After resolving the conflicts," - echo >&2 "mark the corrected paths with 'git-add <paths>'" - echo >&2 "and commit the result." - case "$me" in - cherry-pick) + } >>"$GIT_DIR/MERGE_MSG" + echo >&2 "Automatic $me failed. After resolving the conflicts," + echo >&2 "mark the corrected paths with 'git-add <paths>'" + echo >&2 "and commit the result." + case "$me" in + cherry-pick) echo >&2 "You may choose to use the following when making" echo >&2 "the commit:" echo >&2 "$set_author_env" - esac - exit 1 - } - result=$(git-write-tree) || exit + esac + exit 1 } echo >&2 "Finished one $me." |